#include <bits/stdc++.h>
#define int long long
using namespace std;
const int maxn = 1e5 + 7;
const int maxw = 8192;
vector<pair<int, int>> g[maxn];
bool dali[maxn];
int h[maxn];
void dfs(int u, int xorr, int par)
{
    h[u] = xorr;
    dali[xorr] = true;
    for (auto x : g[u])
    {
        if (x.first == par)
            continue;
        dfs(x.first, xorr ^ x.second, u);
    }
    return;
}
int n;
inline bool check(int xorr)
{
    for (int i = 1; i <= n; i++)
    {
        int target = h[i] ^ xorr;
        if (dali[target])
        {
            return true;
        }
    }
    return false;
}
signed main()
{

    cin >> n;
    for (int i = 0; i < n - 1; i++)
    {
        int a, b, w;
        cin >> a >> b >> w;
        g[a].push_back({b, w});
        g[b].push_back({a, w});
    }
    dfs(1, 0, -1);
    for (int i = maxw; i >= 0; i--)
    {
        if (check(i))
        {
            cout << i << endl;
            return 0;
        }
    }

    return 0;
}
